; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 500
WINDOWHEIGHT = 500

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC) shl 32 + (sizeof WNDCLASSEX)
	push	rax                     ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT

        mov	hWin,rcx
	xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	RtlExitUserProcess,NULL
wmCREATE:invoke	GetDC    ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax;eax=hDC
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hrc,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;GLInit----------------------------------
;     ()
;	invoke glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST;
;     
;	invoke glMatrixMode,GL_PROJECTION;     ()
;    , ..    (  glcall ..     8 )
;	movq	xmm0,constd90
;	movq	xmm1,ratio
;	movq	xmm2,constd0_1
;	movq	xmm3,constd100
;	invoke	gluPerspective
;    
;	invoke	glMatrixMode,GL_MODELVIEW;     ()
;-----------------------------------------
;	invoke	glEnable,GL_ALPHA_TEST
;	invoke	glEnable,GL_BLEND
;	invoke	glBlendFunc,GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA
        mov	r8d,offset mat_ambient
	invoke  glMaterialfv,GL_FRONT,GL_AMBIENT
        mov	r8d,offset mat_specular
	invoke  glMaterialfv,GL_FRONT, GL_SPECULAR
        mov	r8d,offset mat_shininess
	invoke  glMaterialfv,GL_FRONT, GL_SHININESS
	mov	r8d,offset light_position
	invoke	glLightfv,GL_LIGHT0, GL_POSITION
        mov	edx,offset model_ambient
        invoke  glLightModelfv,GL_LIGHT_MODEL_AMBIENT

;	invoke	glEnable,GL_COLOR_MATERIAL
	invoke	glEnable,GL_LIGHTING
	invoke	glEnable,GL_LIGHT0
	invoke	glEnable,GL_DEPTH_TEST

;Create 4 display lists, each with a different quadric object. Different 
;drawing styles and surface normal specifications are demonstrated.
	invoke  glGenLists, 4
	mov	startList,rax
	invoke  gluNewQuadric
	mov	quadObj,rax
	invoke  gluQuadricDrawStyle,eax,GLU_FILL ;smooth shaded
	invoke  gluQuadricNormals,quadObj,GLU_SMOOTH
	invoke  glNewList,startList,GL_COMPILE
	movq	xmm1,constd0_75
	invoke  gluSphere,quadObj,,15,10
	invoke  glEndList
 
	invoke  gluQuadricDrawStyle,quadObj,GLU_FILL ;flat shaded
	invoke  gluQuadricNormals,quadObj, GLU_FLAT
	mov     rax,startList
	add     eax,1*8
	invoke  glNewList,eax,GL_COMPILE
	
	movq	xmm3,constd1
	movq	xmm2,constd0_3
	movq	xmm1,constd0_5
	invoke  gluCylinder,quadObj,,,,15,5
	invoke  glEndList
 
	invoke  gluQuadricDrawStyle,quadObj,GLU_LINE ;all polygons wireframe
	invoke  gluQuadricNormals,quadObj,GLU_NONE
	mov     rax,startList
	add     eax,2*8
	invoke  glNewList,eax,GL_COMPILE
 
	movq	xmm2,constd1
	movq	xmm1,constd0_25
	invoke  gluDisk,quadObj,,,20,4
	invoke  glEndList
 
	invoke  gluQuadricDrawStyle,quadObj,GLU_SILHOUETTE ;boundary only
	invoke  gluQuadricNormals,quadObj, GLU_NONE
	mov	rax,startList
	add     eax,3*8
	invoke  glNewList,eax,GL_COMPILE
;225 -      
;0 -      
;4 -      ,   
;  .
;20 -     Z
	movq	xmm2,constd1;   
	movq	xmm1,rbx ;    (  0)
	invoke  gluPartialDisk,quadObj,,,20,4,rbx,constd225
	invoke  glEndList
	invoke	GLReshape, WINDOWWIDTH, WINDOWHEIGHT
        jmp	wmBYE
wmSIZE:;;     
	movzx	ecx,r9w
	mov	edx,r9d
	shr	edx,16
	invoke	GLReshape
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
;;  
        invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
	invoke	glPushMatrix;  

	invoke  glEnable,GL_LIGHTING
	invoke  glShadeModel,GL_SMOOTH
;spheres
	movd	xmm2,ebx;z
	mov	eax,const_1
	movd	xmm1,eax;y
	movd	xmm0,eax;x
	invoke	glTranslatef;(-4,4,0);	
	invoke  glCallList,startList

        invoke  glShadeModel,GL_FLAT
	movd	xmm2,ebx
	movd	xmm1,const2
	movd	xmm0,ebx	
	invoke  glTranslatef;, 0.0, 2.0, 0.0
	invoke  glPushMatrix
	movd	xmm3,ebx
	movd	xmm2,ebx
	movd	xmm1,const1
	movd	xmm0,const300
	invoke  glRotatef;, 300.0, 1.0, 0.0, 0.0
	mov	rax,startList
	add	eax,1*8
	invoke  glCallList,eax
	invoke	glPopMatrix

        invoke  glDisable, GL_LIGHTING
	mov	eax,const1
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,ebx
	invoke  glColor3f;, 0.0, 1.0, 1.0
	movd	xmm2,ebx
	movd	xmm1,const_2
	movd	xmm0,const2
	invoke  glTranslatef;, 2.0, -2.0, 0.0
	mov	rax,startList
	add     eax,2*8
	invoke  glCallList,eax
	mov	eax,const1
	movd	xmm0,eax
	movd	xmm1,eax
	movd	xmm2,ebx
	invoke  glColor3f;, 1.0, 1.0, 0.0
	movd	xmm2,ebx
	movd	xmm1,const2
	movd	xmm0,ebx
 	invoke  glTranslatef;, 0.0, 2.0, 0.0
	mov     rax,startList
	add     eax,3*8
	invoke  glCallList,eax

	invoke	glPopMatrix
	invoke  glFlush
;   
        invoke	SwapBuffers,hDC
	lea	edx,ps
	invoke	EndPaint,hWin
wmBYE:	leave
	xor	eax,eax
	retn	
WndProc	endp
GLReshape proc w:dword,h:dword
local	resultqa:QWORD
local	resultqb:QWORD
	mov	w,ecx
	mov	h,edx

	mov	r8d,ecx
	mov	r9d,edx
	invoke	glViewport,0,0
	invoke	glMatrixMode,GL_PROJECTION
	invoke	glLoadIdentity
	mov     eax,h
	cmp	w,eax
	ja	@0
	fld	const_2_5
	fimul   h
	fidiv   w
	fstp    resultqa
	fld	const2_5
	fimul   h
	fidiv   w
	fstp    resultqb
	movq	xmm3,resultqb
	movq	xmm2,resultqa
	movq	xmm1,constd2_5
	movq	xmm0,constd_2_5
	invoke  glOrtho,,,,,constd_10,constd10
	jmp	@f
@0:	fld	const_2_5
	fimul	w
	fidiv	h
	fstp	resultqa
	fld	const2_5
	fimul	w
	fidiv	h
	fstp	resultqb
	movq	xmm3,constd2_5
	movq	xmm2,constd_2_5
	movq	xmm1,resultqb
	movq	xmm0,resultqa
	invoke  glOrtho,,,,,constd_10,constd10
@@:	invoke	glMatrixMode,GL_MODELVIEW
        invoke  glLoadIdentity
	leave
	retn
GLReshape endp
;-----------------------------------------------------------
hDC	dq	?
hrc	dq	?;  
PixFrm	label	PIXELFORMATDESCRIPTOR 
;   
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1;  
;  ,     
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or \
	PFD_DRAW_TO_WINDOW 
  	iPixelType        db	PFD_TYPE_RGBA; RGBA 
  	cColorBits        db	16;   
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;  
  	cAlphaBits        db	0;  
  	cAlphaShift       db	0;  
  	cAccumBits        db	0;  
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;  
  	cDepthBits        db	0;32  Z- ( )
  	cStencilBits      db	0;  
  	cAuxBuffers       db	0;  
  	iLayerType        db	PFD_MAIN_PLANE;  
  	bReserved         db	0;
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;  

szClassName	db "Uncle Remus tales:#40 OpenGL - Sphere2",0
FileName	db "br_Rabbit3.cur",0
;float
const1		dd 1.0
const_1		dd -1.0
const2		dd 2.0
const_2		dd -2.0
const2_5	dd 2.5
const_2_5	dd -2.5
const300	dd 300.0
;double----------------------------
constd0_25	dq 0.25
constd0_3	dq 0.3
constd0_5	dq 0.5
constd0_75	dq 0.75
constd1		dq 1.0
constd2_5	dq 2.5
constd_2_5	dq -2.5
constd10	dq 10.0
constd_10	dq -10.0
constd225	dq 225.0

ratio	        dq 1.0;=500/500
startList	dq ?
quadObj		dq ?
mat_ambient	dd 0.5, 0.5, 0.5, 1.0
mat_specular	dd 1.0, 1.0, 1.0, 1.0
mat_shininess	dd 50.0
light_position	dd 1.0, 1.0, 1.0, 0.0
model_ambient	dd 0.5, 0.5, 0.5, 1.0
end